"""
"""
import sys

from types import *
from conf_dialog import Ui_ConfDialog

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from qgis.core import *
from qgis.gui import *

try:
    _fromUtf8 = QString.fromUtf8
except AttributeError:
    _fromUtf8 = lambda s: s

try:
    _toUtf8 = QString.toUtf8
except AttributeError:
    _toUtf8 = lambda s: s

try:
    _toAscii = QString.toAscii
except AttributeError:
    _toAscii = lambda s: s

class menu_conf_dlg(QDialog, Ui_ConfDialog):

    def __init__(self, parent, plugin):
        self.plugin = plugin
        self.parent = parent
        QDialog.__init__(self, parent)
        self.setupUi(self)
        self.defaultcursor = self.cursor
        
        self.tableWidget.horizontalHeader().setResizeMode(QHeaderView.ResizeToContents)
        self.tableWidget.setRowCount (len(self.plugin.projects))
        QObject.connect(self.buttonBox, SIGNAL("accepted()"), self.onAccepted)
        QObject.connect(self.buttonBox, SIGNAL("rejected()"), self.onRejected)
        QObject.connect(self.btnAdd, SIGNAL("clicked()"), self.onAdd)
        QObject.connect(self.btnDelete, SIGNAL("clicked()"), self.onDelete)

        idx = 0
        for project in self.plugin.projects:
            pushButton = QToolButton(self.parent)
            pushButton.setGeometry(QRect(0, 0, 20, 20))
            pushButton.setObjectName(_fromUtf8("x"))
            pushButton.setText("...")
            
            itemName = QTableWidgetItem(project["name"])
            itemName.setFlags(Qt.ItemIsSelectable | Qt.ItemIsEnabled )
            self.tableWidget.setItem(idx, 2, itemName)

            itemFile = QTableWidgetItem((project["file"]))
            itemFile.setFlags(Qt.ItemIsSelectable | Qt.ItemIsEnabled )
            self.tableWidget.setItem(idx, 1, itemFile)

            le = QLineEdit()
            le.setText((project["name"]))
            self.tableWidget.setCellWidget(idx, 2, le)
            
            self.tableWidget.setCellWidget(idx, 0, pushButton)
            
            QObject.connect(pushButton, SIGNAL("clicked()"), lambda _idx=idx: self.onFileSearchPressed(_idx))
            
            idx = idx+1
        
        self.tableWidget.horizontalHeader().setResizeMode(0, QHeaderView.Fixed)
        self.tableWidget.horizontalHeader().resizeSection(0, 20) 
        self.tableWidget.horizontalHeader().setResizeMode(1, QHeaderView.Interactive)
        self.tableWidget.horizontalHeader().setResizeMode(2, QHeaderView.Interactive)
        #self.tableWidget.horizontalHeader().resizeSection(2, 20) 
        
        self.cbxLoadAll.setChecked(self.plugin.optionLoadAll.toBool())
        self.cbxLoadAll.setTristate(False)

        if (QGis.QGIS_VERSION_INT >= 10900):
            self.cbxCreateGroup.setCheckState(self.plugin.optionCreateGroup.toBool())
            self.cbxCreateGroup.setTristate(False)
        else:
            self.cbxCreateGroup.setVisible(False)
        
        self.cbxShowTooltip.setCheckState(self.plugin.optionTooltip.toBool())
        self.cbxShowTooltip.setTristate(False)

    def onFileSearchPressed(self, row):
        item = self.tableWidget.item(row, 1)

        filePath = QFileDialog.getOpenFileName(self, QApplication.translate("menu_from_project", "Projects configuration", None, QApplication.UnicodeUTF8), item.text(), QApplication.translate("menu_from_project", "QGis projects (*.qgs)", None, QApplication.UnicodeUTF8))
        if filePath != "":
            itemFile = QTableWidgetItem(filePath)
            itemFile.setFlags(Qt.ItemIsSelectable | Qt.ItemIsEnabled )
            self.tableWidget.setItem(row, 1, itemFile)

            le = self.tableWidget.cellWidget(row, 2)
            name = le.text()
            if name == "":
                name = filePath.split('/')[-1]
                name = name.split('.')[0]
                le.setText(name)
        
    def onAccepted(self):
        self.plugin.projects = []
        for row in range(self.tableWidget.rowCount()):
            itemFile = self.tableWidget.item(row, 1)
            if itemFile.text() != "":
                le = self.tableWidget.cellWidget(row, 2)
                name = le.text()
                filename = itemFile.text()
                if name == "":
                    name = filename.split('/')[-1]
                    name = name.split('.')[0]
                    
                self.plugin.projects.append({"file":(filename), "name":(name)})
        
        self.plugin.optionTooltip = QVariant(self.cbxShowTooltip.isChecked())
        self.plugin.optionLoadAll = QVariant(self.cbxLoadAll.isChecked())
        self.plugin.optionCreateGroup = QVariant(self.cbxCreateGroup.isChecked())
        
        self.plugin.store()

    def onRejected(self):
        pass

    def onAdd(self):
        row = self.tableWidget.rowCount()
        self.tableWidget.setRowCount(row+1)
        
        pushButton = QToolButton(self.parent)
        pushButton.setGeometry(QRect(0, 0, 20, 20))
        pushButton.setObjectName(_fromUtf8("x"))
        pushButton.setText("...")
        
        itemName = QTableWidgetItem("")
        itemName.setFlags(Qt.ItemIsSelectable | Qt.ItemIsEnabled )
        self.tableWidget.setItem(row, 2, itemName)

        itemFile = QTableWidgetItem("")
        itemFile.setFlags(Qt.ItemIsSelectable | Qt.ItemIsEnabled )
        self.tableWidget.setItem(row, 1, itemFile)

        le = QLineEdit()
        le.setText("")
        self.tableWidget.setCellWidget(row, 2, le)
        
        self.tableWidget.setCellWidget(row, 0, pushButton)
        QObject.connect(pushButton, SIGNAL("clicked()"), lambda _idx=row: self.onFileSearchPressed(_idx))

    def onDelete(self):
        sr = self.tableWidget.selectedRanges()
        try:
            self.tableWidget.removeRow(sr[0].topRow())
        except:
            pass 
